/*
         2݌v} 03

   2002/ 3/ 1 - 2003/ 2/ 3 ˁ@P
*/

#include "B2Windef.h"
#include "classes.h"

B2StringVector::B2StringVector() {

	_i32Strings = 0;
	_i32Allocated = B2StringVector_MIN;

	_ppbsVector = new B2String*[_i32Allocated];

}

B2StringVector::B2StringVector(const B2Strings *pbssArg) {

	_i32Strings = 0;
	_i32Allocated = B2StringVector_MIN;

	_ppbsVector = new B2String*[_i32Allocated];

	assign(pbssArg);

}

B2StringVector::B2StringVector(const B2StringVector& bsvArg) {

	_i32Strings=0;
	_i32Allocated=B2StringVector_MIN;

	_ppbsVector=new B2String*[_i32Allocated];

	assign(&bsvArg);

}

bool B2StringVector::assign(const B2Strings *pbssArg) {

	if (pbssArg==NULL)
		return false;

	clear();

	if (!alloc(pbssArg->getSize()))
		return false;

	for (int i = 0;i < pbssArg->getSize();i++)
		add(pbssArg->getString(i));
	
	return true;

}

B2StringVector & B2StringVector::operator=(const B2StringVector& bsArg) {

	if (&bsArg!=this)
		assign(&bsArg);

	return *this;

}

B2StringVector B2StringVector::operator+(const STR8 s8Arg) {

	B2StringVector bsvTmp=*this;

	bsvTmp.add(s8Arg);

	return bsvTmp;

}

B2StringVector B2StringVector::operator+(const B2String *pbsArg) {

	B2StringVector bsvTmp=*this;

	bsvTmp.add(pbsArg);

	return bsvTmp;

}

B2StringVector& B2StringVector::operator+=(const STR8 s8Arg) {

	add(s8Arg);

	return *this;

}

B2StringVector& B2StringVector::operator+=(const B2String *pbsArg) {

	add(pbsArg);

	return *this;

}

bool B2StringVector::add(const STR8 s8Arg) {

	if (s8Arg==NULL)
		return false;

	if (!alloc(_i32Strings + 1))
		return false;

	_ppbsVector[_i32Strings++] = new B2String_DEFAULT_CLASS(s8Arg);

	return true;

}

bool B2StringVector::add(const B2String *bsArg) {

	I32 i32Class=bsArg->getClass();

	if (!alloc(_i32Strings + 1))
		return false;

	switch (i32Class) {

	case CLASS_B2String1:

		_ppbsVector[_i32Strings++] = (B2String *)(new B2String1(bsArg));

		break;

	default:

		return false;

	}

	return true;

}

I32 B2StringVector::add(const B2Strings *pbssArg) {

	if (pbssArg==NULL)
		return 0;

	I32 i;

	for (i=0;i<pbssArg->getSize();i++)
		add(pbssArg->getString(i));

	return i;

}

bool B2StringVector::alloc(I32 i32Arg) {

	if (i32Arg <= _i32Allocated)
		return true;

	if (i32Arg > B2StringVector_MAX) {
		return false;
	}

	I32 i32Alloc = _i32Allocated * 2;

	if (i32Alloc > B2StringVector_MAX) {
		i32Alloc = B2StringVector_MAX;
	}

	B2String **ppbsNew = new B2String*[i32Alloc];

	if (ppbsNew == NULL) {
		return false;
	}

	for (int i = 0;i < _i32Strings;i++) {
		ppbsNew[i] = _ppbsVector[i];
	}

	delete [] _ppbsVector;
	_ppbsVector = ppbsNew;

	_i32Allocated = i32Alloc;

	return true;

}

bool B2StringVector::clear() {

	I32 i;

	if (_i32Strings==0)
		return true;

	for (i = 0;i < _i32Strings;i++) {
		delete _ppbsVector[i];
	}

	delete [] _ppbsVector;
	_ppbsVector = NULL;

	_i32Strings=0;

	_i32Allocated = B2StringVector_MIN;

	_ppbsVector = new B2String*[_i32Allocated];

	return true;

}

B2String * B2StringVector::getString(I32 i32Arg) const {

	if (i32Arg<0 || i32Arg >= _i32Strings)
		return NULL;

	return _ppbsVector[i32Arg];

}

B2String * B2StringVector::operator[](I32 i32Arg) const {

	return getString(i32Arg);

}

I32 B2StringVector::getSize() const { return _i32Strings; }

bool B2StringVector::erase(I32 i32Arg) {
	
	if (i32Arg<0 || i32Arg >= _i32Strings)
		return false;

	delete _ppbsVector[i32Arg];

	for (I32 i = i32Arg;i < _i32Strings-1;i++) {
		_ppbsVector[i] = _ppbsVector[i+1];
	}

	_i32Strings--;

	return true;

}

B2StringVector::~B2StringVector() {

	I32 i;

	for (i = 0;i < _i32Strings;i++)
		delete _ppbsVector[i];

	delete [] _ppbsVector;

}
