/*
        2݌v} 03

  2002/ 3/ 1 - 2003/ 2/ 3 ˁ@P
*/
#pragma once

#define B2String1_MIN_SIZE 32
#define B2String1_MAX_SIZE 40000000
#define B2StringVector_MIN 32
#define B2StringVector_MAX 4194305
#define CLASS_B2String1 8
#define B2String_ENCODE_NONE 0

class B2String1;
class B2Strings;

typedef B2String1 B2String_DEFAULT_CLASS;

// C^[tF[XNX
class B2String {

public:

	virtual bool assign(const BUF,I32)=0;
	virtual bool assign(const STR8)=0;
	virtual bool assign(const B2String *)=0;
	virtual bool append(const BUF,I32)=0;
	virtual bool append(const STR8)=0;
	virtual bool append(BYTE)=0;
	virtual bool equal(const BUF,I32) const=0;
	virtual bool equal(const STR8) const=0;
	virtual bool equal(const B2String *) const=0;

	virtual const STR8 c_str()=0;

	virtual I32 getChr(I32) const=0;
	virtual I32 getLastBufferIndex() const=0;
	virtual BYTE getByte(I32) const=0;
	virtual BUF getBuffer() const=0;
	virtual I32 getBufferSize() const=0;
	virtual I32 getStringSize() const=0;
	virtual I32 getClass() const=0;
	virtual I32 getEncoding() const=0;

	virtual I32 search(const BUF,I32) const=0;
	virtual I32 search(I32,BYTE) const = 0;
	virtual I32 search(I32,const BUF,I32) const=0;
	virtual I32 search(const STR8) const=0;
	virtual I32 search(BYTE) const=0;
	virtual I32 searchN(const BUF,I32) const=0;
	virtual I32 searchN(const STR8) const=0;
	virtual I32 rsearch(const BUF,I32) const=0;
	virtual I32 rsearch(const STR8) const=0;

	virtual bool inStr(const STR8) = 0;

	virtual bool setBuffer(I32,const BUF,I32)=0;
	virtual bool setByte(I32,BYTE)=0;

	virtual B2Strings* split(const BUF,I32) const =0;
	virtual B2Strings* split(const STR8) const =0;
	virtual B2Strings* split(BYTE) const =0;

	virtual I32 replace(const BUF,I32,const BUF,I32)=0;
	virtual I32 replace(const STR8,const STR8)=0;

	virtual bool del(I32)=0;
	virtual bool del(I32,I32)=0;
	virtual I32 trim(BYTE)=0;
	virtual void URLDecode() = 0;
	virtual bool isHexChr(BYTE) = 0;
	virtual int getHexVal(BYTE) = 0;

	virtual bool loadFile(const STR8)=0;
	virtual bool saveFile(const STR8) const=0;

	virtual ~B2String() {}

};

// PoCgNX
class B2String1:public B2String {

public:

	B2String1();
	B2String1(const BUF,I32);
	B2String1(const STR8);
	B2String1(const B2String *);
	B2String1(const B2String1&);

	virtual bool assign(const BUF,I32);
	virtual bool assign(const STR8);
	virtual bool assign(const B2String *);
	virtual bool equal(const BUF,I32) const;
	virtual bool equal(const STR8) const;
	virtual bool equal(const B2String *) const;

	B2String1 & operator=(const STR8);
	B2String1 & operator=(const B2String1&);
	virtual bool operator==(const STR8) const;
	virtual bool operator==(const B2String1& bsArg) const;
	virtual B2String1 operator+(const STR8);
	virtual B2String1 operator+(const B2String1&);
	virtual B2String1 & operator+=(const STR8);
	virtual B2String1 & operator+=(const B2String1&);

	virtual BYTE getByte(I32) const;
	virtual I32 getChr(I32) const;
	virtual BUF getBuffer() const;
	virtual I32 getBufferSize() const;
	virtual I32 getStringSize() const;
	virtual I32 getClass() const;
	virtual I32 getLastBufferIndex() const;
	virtual I32 getEncoding() const;
	virtual I32 getMinSize() const;
	virtual I32 getMaxSize() const;

	virtual const STR8 c_str();

	virtual bool append(BYTE);
	virtual bool append(const BUF,I32);
	virtual bool append(const STR8);
	virtual bool append(const B2String1&);
	virtual bool setBuffer(I32,const BUF,I32);
	virtual bool setByte(I32,BYTE);

	virtual I32 search(I32,const BUF,I32) const;
	virtual I32 search(I32,BYTE) const;
	virtual I32 search(const BUF,I32) const;
	virtual I32 search(const STR8) const;
	virtual I32 search(BYTE) const;
	virtual I32 searchN(const BUF,I32) const;
	virtual I32 searchN(const STR8) const;
	virtual I32 rsearch(const BUF,I32) const;
	virtual I32 rsearch(const STR8) const;

	virtual bool inStr(const STR8);

	virtual B2Strings * split(const BUF,I32) const;
	virtual B2Strings * split(const STR8) const;
	virtual B2Strings * split(BYTE) const;

	virtual I32 replace(const BUF,I32,const BUF,I32);
	virtual I32 replace(const STR8,const STR8);

	virtual bool del(I32);
	virtual bool del(I32,I32);
	virtual I32 trim(BYTE);
	virtual void URLDecode();
	virtual bool isHexChr(BYTE);
	virtual int getHexVal(BYTE);

	virtual bool loadFile(const STR8);
	virtual bool saveFile(const STR8) const;

	~B2String1();

private:

	BUF bfBuffer;
	STR8 s8C_Str;
	I32 i32AllocSize,i32BufferSize,i32MIN_SIZE,i32MAX_SIZE;

	void init();
	void clear();
	bool resizeBuffer(I32);
	bool setC_Str();

};

class B2Strings {

public:

	virtual bool assign(const B2Strings *)=0;
	virtual B2String * getString(I32) const=0;
	virtual B2String * operator[](I32) const=0;
	virtual I32 getSize() const=0;
	virtual bool clear()=0;
	virtual bool add(const STR8)=0;
	virtual bool add(const B2String *)=0;
	virtual I32 add(const B2Strings *)=0;
	virtual bool erase(I32)=0;

	virtual ~B2Strings() {}

};

class B2StringVector:public B2Strings {

public:

	B2StringVector();
	B2StringVector(const B2Strings *);
	B2StringVector(const B2StringVector&);

	virtual bool assign(const B2Strings *);

	B2StringVector& operator=(const B2StringVector&);
	virtual B2StringVector operator+(const STR8);
	virtual B2StringVector operator+(const B2String *);
	virtual B2StringVector & operator+=(const STR8);
	virtual B2StringVector & operator+=(const B2String *);

	virtual B2String * getString(I32) const;
	virtual B2String * operator[](I32) const;
	virtual I32 getSize() const;
	virtual bool clear();
	virtual bool add(const STR8);
	virtual bool add(const B2String *);
	virtual I32 add(const B2Strings *);
	virtual bool erase(I32);

	~B2StringVector();

private:

	B2String **_ppbsVector;
	I32 _i32Strings, _i32Allocated;

	bool alloc(I32);

};

class B2StringMapItem {

public:

	B2StringMapItem() {
	
		pbsKey=new B2String_DEFAULT_CLASS();
		pbsValue=new B2String_DEFAULT_CLASS();

	}

	B2StringMapItem(const B2String *pbsArg1,const B2String *pbsArg2) {
	
		pbsKey=new B2String_DEFAULT_CLASS(pbsArg1);
		pbsValue=new B2String_DEFAULT_CLASS(pbsArg2);

	}

	B2StringMapItem(const STR8 s8Arg1,const STR8 s8Arg2) {
	
		pbsKey=new B2String_DEFAULT_CLASS(s8Arg1);
		pbsValue=new B2String_DEFAULT_CLASS(s8Arg2);

	}

	virtual B2String * getKey() const { return pbsKey; }
	virtual B2String * getValue() const { return pbsValue; }
	virtual bool setKey(const B2String *pbsArg) {	return pbsKey->assign(pbsArg); }
	virtual bool setKey(const STR8 s8Arg) {	return pbsKey->assign(s8Arg); }
	virtual bool setValue(const B2String *pbsArg) { return pbsValue->assign(pbsArg); }
	virtual bool setValue(const STR8 s8Arg) { return pbsValue->assign(s8Arg); }

	virtual ~B2StringMapItem() {

		delete pbsKey;
		delete pbsValue;

	}

private:

	B2String *pbsKey,*pbsValue;

};

class B2StringListMapItem:public B2StringMapItem {

public:

	B2StringListMapItem(const B2String *pbsArg1,const B2String *pbsArg2,
	                    const B2StringListMapItem *pbmArg1,const B2StringListMapItem *pbmArg2) {

		if (pbsArg1==NULL ||pbsArg1->getStringSize()<1)
			return;

		setKey(pbsArg1);
		setValue(pbsArg2);
		setBack(pbmArg1);
		setNext(pbmArg2);

	}

	B2StringListMapItem(const STR8 s8Arg1,const STR8 s8Arg2,
	                    const B2StringListMapItem *pbmArg1,const B2StringListMapItem *pbmArg2) {

		if (s8Arg1==NULL ||s8Arg1[0]==0)
			return;

		setKey(s8Arg1);
		setValue(s8Arg2);
		setBack(pbmArg1);
		setNext(pbmArg2);

	}

	B2StringListMapItem * getBack() const { return pbmBack; }
	B2StringListMapItem * getNext() const { return pbmNext; }

	bool setBack(const B2StringListMapItem *pbmArg) {
		
		pbmBack=(B2StringListMapItem *)pbmArg;
		return true;
	}

	bool setNext(const B2StringListMapItem *pbmArg) {
	
		pbmNext=(B2StringListMapItem *)pbmArg;
		return true;
	
	}

private:

	B2StringListMapItem *pbmBack,*pbmNext;

};

class B2StringMap {

public:

	virtual B2String * getValue(const B2String *) const=0;
	virtual B2String * getValue(const STR8) const=0;
	virtual I32 getSize() const=0;

	virtual bool add(const B2String *,const B2String *)=0;
	virtual bool add(const STR8,const STR8)=0;

	virtual bool set(const B2String *,const B2String *)=0;
	virtual bool set(const STR8,const STR8)=0;

	virtual bool erase(const B2String *)=0;
	virtual bool erase(const STR8)=0;

	virtual bool clear()=0;

	virtual ~B2StringMap() {}

};

class B2StringListMap:public B2StringMap {

public:

	B2StringListMap();

	virtual B2String * getValue(const B2String *) const;
	virtual B2String * getValue(const STR8) const;
	virtual bool search (const B2String *) const;
	virtual bool search (const STR8) const;
	virtual I32 getSize() const;

	virtual bool add(const B2String *,const B2String *);
	virtual bool add(const STR8,const STR8);

	virtual bool set(const B2String *,const B2String *);
	virtual bool set(const STR8,const STR8);

	virtual bool erase(const B2String *);
	virtual bool erase(const STR8);

	virtual bool clear();

	virtual B2String * operator[](const B2String *);
	virtual B2String * operator[](const STR8);

	~B2StringListMap();

protected:

	virtual B2StringListMapItem * getFirstItem() const;
	virtual B2StringListMapItem * getLastItem() const;

private:

	B2StringListMapItem *pbmFirst,*pbmLast;
	I32 i32Items;
	B2String_DEFAULT_CLASS bsEmpty;

};
